#ifndef WS2811_H
#define WS2811_H

#include "stdint.h"
#include <stdio.h>

//Attention!! Hardware dependancy!!
#include "stm32f4xx.h"

#define COLOR_PAUSE 0x000a0a
#define COLOR_PLAY1  0x0a0003
#define COLOR_PLAY2 0x03000a
#define COLOR_STANDBY  0x000a00
#define COLOR_OFF 0x00000

//#define WS2811_TIM_FREQ      21000000
//#define WS2811_OUT_FREQ        400000

//#define WS2811_BIT_TRANSFER_DURATION 2500 //in nS per Bit
//#define WS2811_DATA_TRANSFER_DURATION (WS2811_BIT_TRANSFER_DURATION*WS2811_FRAMEBUF_LEN/1000) //complete Frame Transfer duration in S
//#define WS2811_FRAMERATE	(1000000 / WS2811_DATATRANSFER_DURATION) //in Frames/second

//------------------------------ structs ------------------------------
typedef struct{
	uint8_t R;
	uint8_t G;
	uint8_t B;
} color;

// ----------------------------- functions -----------------------------
void ws2811_init(void);
void updateLED(void);

// ----------------------------- graphics -----------------------------

void setLED(uint led, uint8_t r, uint8_t g, uint8_t b);
void setLED_Color(uint led, color *c);
void setLED_32(uint led, uint32_t rgb);
void setAllLED(uint8_t r, uint8_t g, uint8_t b);
void setAllLED_Color(color *c);
void setAllLED_32(uint32_t rgb);
void clearAllLED();



//debug functions
#ifdef DEBUGMODE
void startTimer(void);
uint32_t stopTimer(void);
#endif

#endif
